%% CALCULATE FEATURES
% This file appends a simple hp-filter on the signal and calculates the features assigned.

% TODO
% LIST = dir([dir_setup 'features/EMG' cell2mat(feature(i))]);
% LIST.name -> find filename
% LIST.date -> check date, and match against date found from EMGfeature.m.
% IF date not equal then we should generate feature.

 for g=1:length(subjects)
     disp(cell2mat(subjects(g)))
     for h=1:length(dataset)
        disp(cell2mat(dataset(h)))
         %emg data files are located in source_data folder.
         filename = ['src/EMG/EMG_' cell2mat(subjects(g)) '_' cell2mat(dataset(h)) '.mat'];
         load(filename);
         disp(filename)
         disp('processing..')
         
         % EMG variabel loaded contains 8 rawEMG signals+time.
         X1 = EMG(2:9,:);
         clear EMG
    
         numEMGsamples = size(X1,2); % # samples in orignal set
         newSamples = numEMGsamples/scale; % # samples with freq_down Hz.
         
         %% Flter X1 with high-pass filter.
         X2 = hpfilter(X1,hpfilter_gain,hpfilter_frequency);
    
         %% Calculate features
         % Looping through all the features set up in the features array
         % defined in init.
         for i=1:length(features)
            disp(features(i))
            FE = upper(features(i)); %uppercase on the Variable to hold the data we want to save. Same as the one returning from a function.
            tic
            eval([cell2mat(FE) ' = EMG' cell2mat(features(i)) '(X2,newSamples,scale);']); %define the function we want to use
            toc
            filename = [dir_setup 'features/EMG' cell2mat(features(i)) '/EMG_' cell2mat(features(i)) '_' cell2mat(subjects(g)) '_' cell2mat(dataset(h)) '.mat'];
            %define path/filename, and then save.
            save(filename,cell2mat(FE));
            eval(['clear FE ' cell2mat(features(i))])
         end
     end
 end
 clear X2 X1 filename numEMGsamples newSamples i g h