function generateEstimationInput_features(data,source,feature)
global freq VICON_freq dir_setup;

load('src/angles.mat') % This should somehow be decleared in the runProgram, to reduce load/clear time.
% Problem lies in making the eval([data '.' source]) catch the global variable.

oldfile = [dir_setup 'features/EMG' feature '/EMG_' feature '_' data '_' source '.mat'];
newfile = [dir_setup 'input/EMG' feature '/XF_' feature '_' data '_' source '.mat'];

eval(['datasource = ' data '.' source ';'])

F1 = [datasource.angles.fffeAngle; datasource.angles.wfweAngle; ...
    datasource.angles.prosupAngle; datasource.angles.rdudAngle];
F1 = real(F1);

% Sample F to fit X(features)
VICONsamples = size(F1,2);
bothSamples = VICONsamples * freq/VICON_freq;
scale = VICONsamples/bothSamples;

for k=1:bothSamples
    for t=1:4
        F2(t,k) = mean(F1(t,(k-1)*scale+1:k*scale));
    end
end

load(oldfile);
X2 = eval(upper(feature));
% Remove time steps where data is missing
F = 0;
for k=1:bothSamples
    if ~( isnan(F2(1,k)) | isnan(F2(2,k)) | isnan(F2(3,k)) | isnan(F2(4,k)) )
        if F == 0
            F = F2(:,k);
            X = X2(:,k,:);
        else
            F = [F F2(:,k)];
            X = [X X2(:,k,:)];
        end
    end
end

save(newfile,'X','F');