%% CREATE THE DATASTRUCTE TO BE USED TO SAVE GENERATED DATA

% data/20090319/EMG20Hz/features/EMGfeature(i)

warning off MATLAB:MKDIR:DirectoryExists;

%calculated data will be stored here
for i=1:length(features)
    mkdir([dir_setup '/features/EMG' cell2mat(features(i))]);
    mkdir([dir_setup '/input/EMG' cell2mat(features(i))]);
    for j=1:run
        mkdir([dir_setup '/mapping/EMG' cell2mat(features(i)) '/DATA/run' num2str(j)]);
        mkdir([dir_setup '/mapping/EMG' cell2mat(features(i)) '/Performance/run' num2str(j)]);
    end
end
%plotted data will be stored here
for i=1:length(subjects)
    for j=1:length(dataset)
        mkdir([dir_setup '/gfx/features/' cell2mat(subjects(i)) '/' cell2mat(dataset(j)) ]);
        mkdir([dir_setup '/gfx/mapping/' cell2mat(subjects(i)) '/' cell2mat(dataset(j)) ]);
    end
end

mkdir([dir_setup '/results']);